#!/usr/bin/python
import sys
import os
from gi.repository import Gtk

global file_list
global imgPref
global imgSize
global filePref

file_list = []
imgPref = 1
filePref = 1
imgSize = ""

if len(sys.argv) >= 2:
	for arg in sys.argv[1:]:
		file_list.append (arg)
else:
	print "Syntax: %s file1 file2...\n" % sys.argv[0]

class ResizeImage(Gtk.Window):

	def __init__(self):
		Gtk.Window.__init__(self, title="Resize image")

		self.set_border_width(30)
		contenitore_gen = Gtk.VBox(spacing=10)
		box_tit_img = Gtk.HBox(False,0)
		box_size = Gtk.HBox(False,10)
		box_scale = Gtk.HBox(False,10)
		box_custom = Gtk.HBox(False,10)
		box_tit_filename = Gtk.HBox(False,0)
		box_append = Gtk.HBox(False,10)
		box_resize = Gtk.HBox(False,10)
		box_path = Gtk.HBox(False,10)
		box_button = Gtk.HBox(False,0)

		tit_img = Gtk.Label()
		tit_img.set_markup("<b>Image Size</b>")
		box_tit_img.pack_start(tit_img, False, False, 0)

		button1 = Gtk.RadioButton.new_with_label_from_widget(None, "Select a size:")
		button1.connect("toggled", self.on_button_image, "1")
		box_size.pack_start(button1, False, False, 0)

		button2 = Gtk.RadioButton.new_from_widget(button1)
		button2.set_label("Scale:")
		button2.connect("toggled", self.on_button_image, "2")
		box_scale.pack_start(button2, False, False, 0)

		button3 = Gtk.RadioButton.new_from_widget(button1)
		button3.set_label("Custom size:")
		button3.connect("toggled", self.on_button_image, "3")
		box_custom.pack_start(button3, False, False, 0)

		size_store = Gtk.ListStore(str)
		sizes = ["96x96", "128x128", "640x480", "800x600", "1024x768", "1280x960"]
		for size in sizes:
			size_store.append([size])

		size_combo = Gtk.ComboBox.new_with_model(size_store)
		size_combo.connect("changed", self.on_size_combo_changed)
		renderer_text = Gtk.CellRendererText()
		size_combo.pack_start(renderer_text, True)
		size_combo.add_attribute(renderer_text, "text", 0)

		tit_pixel = Gtk.Label("pixels")
		box_size.pack_start(size_combo, True, True, 0)
		box_size.pack_start(tit_pixel, False, False, 0)

		adjustment = Gtk.Adjustment(50, 1, 100, 1, 10, 0)
		self.scale = Gtk.SpinButton()
		self.scale.set_adjustment(adjustment)
		self.scale.set_value(50)

		tit_percent = Gtk.Label("percent")
		box_scale.pack_start(self.scale, True, True, 0)
		box_scale.pack_start(tit_percent, False, False, 0)

		tit_w = Gtk.Label("Width:")
		tit_h = Gtk.Label("Height:")
		tit_p = Gtk.Label("pixels")

		adjustmentw = Gtk.Adjustment(1000, 1, 10000, 1, 10, 0)
		self.width = Gtk.SpinButton()
		self.width.set_adjustment(adjustmentw)
		self.width.set_value(1000)

		adjustmenth = Gtk.Adjustment(1000, 1, 10000, 1, 10, 0)
		self.height = Gtk.SpinButton()
		self.height.set_adjustment(adjustmenth)
		self.height.set_value(1000)
		box_custom.pack_start(tit_w, False, False, 0)
		box_custom.pack_start(self.width, True, True, 0)
		box_custom.pack_start(tit_h, False, False, 0)
		box_custom.pack_start(self.height, True, True, 0)
		box_custom.pack_start(tit_p, False, False, 0)

		tit_file = Gtk.Label()
		tit_file.set_markup("<b>Filename</b>")
		box_tit_filename.pack_start(tit_file, False, False, 0)

		btnAppend = Gtk.RadioButton.new_with_label_from_widget(None, "Append:")
		btnAppend.connect("toggled", self.on_button_filename, "1")
		box_append.pack_start(btnAppend, False, False, 0)

		btnPlace = Gtk.RadioButton.new_from_widget(btnAppend)
		btnPlace.set_label("Resize in place")
		btnPlace.connect("toggled", self.on_button_filename, "2")
		box_resize.pack_start(btnPlace, False, False, 0)

		btnPath = Gtk.RadioButton.new_from_widget(btnAppend)
		btnPath.set_label("Save in:")
		btnPath.connect("toggled", self.on_button_filename, "3")
		box_path.pack_start(btnPath, False, False, 0)

		self.append = Gtk.Entry()
		self.append.set_text(".resized")
		tit_append = Gtk.Label("to file title")
		box_append.pack_start(self.append, True, True, 0)
		box_append.pack_start(tit_append, False, False, 0)

		self.path = Gtk.Entry()
		box_path.pack_start(self.path, True, True, 0)
		btnFolder = Gtk.Button()
		btnFolder.set_label("Choose folder")
		btnFolder.connect("clicked", self.on_folder_clicked)
		box_path.pack_start(btnFolder, False, False, 0)

		btnResize = Gtk.Button(label="Resize")
		btnResize.connect("clicked", self.on_button_resize)
		btnResize.set_size_request(100,30)
		btnClose = Gtk.Button(stock=Gtk.STOCK_CANCEL)
		btnClose.connect("clicked", self.on_close_clicked)
		btnClose.set_size_request(100,30)
		box_button.pack_end(btnResize, False, False, 0)
		box_button.pack_end(btnClose, False, False, 10)
		
		contenitore_gen.pack_start(box_tit_img, True, False, 0)
		contenitore_gen.pack_start(box_size, True, False, 0)
		contenitore_gen.pack_start(box_scale, True, False, 0)
		contenitore_gen.pack_start(box_custom, True, False, 0)
		contenitore_gen.pack_start(box_tit_filename, True, False, 0)
		contenitore_gen.pack_start(box_append, True, False, 0)
		contenitore_gen.pack_start(box_resize, True, False, 0)
		contenitore_gen.pack_start(box_path, True, False, 0)
		contenitore_gen.pack_start(box_button, True, False, 0)
		self.add(contenitore_gen)

	def on_button_resize(self, widget):
		if imgPref==1:
			Size=imgSize
		elif imgPref==2:
			Size=str(int(self.scale.get_value()))
		else:
			Size=str(int(self.width.get_value()))+"x"+str(int(self.height.get_value()))

		ImgTot = len(file_list)
		for a in range (0, ImgTot):
			fn = self.FileName(file_list[a])
			if imgPref==1 or imgPref==3:
				s=os.system("convert '"+file_list[a]+"' -resize "+Size+" '"+fn+"'")
			else:
				s=os.system("convert '"+file_list[a]+"' -scale "+Size+"% '"+fn+"'")
		Gtk.main_quit()


	def FileName(self,f):
		if filePref==1:
			File = os.path.splitext(f)[0]+self.append.get_text()+os.path.splitext(f)[1]
		elif filePref==2:
			File = f
		else:
			File = os.path.join( self.path.get_text(),os.path.split(f)[1] )
		return File

	def on_close_clicked(self, button):
		Gtk.main_quit()

	def on_button_image(self, button, name):
		global imgPref
		if button.get_active():
			imgPref = int(name)

	def on_button_filename(self, button, name):
		global filePref
		if button.get_active():
			filePref = int(name)

	def on_size_combo_changed(self, combo):
		global imgSize
		tree_iter = combo.get_active_iter()
		if tree_iter != None:
			model = combo.get_model()
			imgSize = model[tree_iter][0]

	def on_folder_clicked(self, widget):
		dialog = Gtk.FileChooserDialog("Please choose a folder", self,
			Gtk.FileChooserAction.SELECT_FOLDER,
			(Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL,
			 "Select", Gtk.ResponseType.OK))
		dialog.set_default_size(800, 400)

		response = dialog.run()
		if response == Gtk.ResponseType.OK:
			self.path.set_text( dialog.get_filename() )
			print "Select clicked"
			print "Folder selected: " + dialog.get_filename()
		elif response == Gtk.ResponseType.CANCEL:
			print "Cancel clicked"

		dialog.destroy()

win = ResizeImage()
win.connect("delete-event", Gtk.main_quit)
win.show_all()
Gtk.main()
